# ==============================================================================
# | view.py                                                                    |
# |                                                                            |
# |                                                                            |
# |                                                                            |
# | Transaction view                                                           |
# ==============================================================================


# PyQt
from PyQt5          import QtCore, QtGui, QtWidgets
from PyQt5.QtCore   import Qt



# ------------------------------------------------------------------------------
# | TransactionTableView                                                       |
# |                                                                            |
# |                                                                            |
# | Custom view, subclassed from QTableView                                    |
# ------------------------------------------------------------------------------
class TransactionTableView(QtWidgets.QTableView):

    def __init__(self, parent=None):
        super().__init__(parent)
        print(f'Created Transaction View')

    def setModel(self, model):
        super().setModel(model)

    def keyPressEvent(self, event):
        key = event.key()
        mod = int(event.modifiers())
        row = self.currentIndex().row()
        col = self.currentIndex().column()

        if key == Qt.Key_Q and mod == Qt.ControlModifier:
            main_win = self.parent().parent().close()
            return

        elif key == Qt.Key_Space:
            menu = QtWidgets.QMenu()
            for s in ('Foo', 'Bar', 'Baz'):
                menu.addAction(QtGui.QIcon('account.png'), s)
            menu.setActiveAction(menu.actions()[0])
            menu.exec(self.mapToGlobal(QtCore.QPoint(20, 20)))
            return

        super().keyPressEvent(event)
